c
c locates cosmic rays from a list of images, by looking at
c subsections for which iraf has already determined the sigma
c outputs a map file
c  value = the detection limit (="high" from calling script)
c  
c maxfiles may exceed the operating system limit!
	parameter (maxfiles=40,maxrowl=4096,maxline=4608)
	real data1(maxrowl,maxline),data2(maxrowl,maxline)
	real datam(maxrowl,maxline)
	integer*2 data3(maxrowl,maxline),data4(maxrowl,maxline)
	integer im(maxfiles), axlen(7), low, high, ngdval(maxfiles+1)
	integer dtype,numn
c	integer*2 data(maxrowl, maxfiles)
	real	datat(100000),datat2(100000)
        real  odata(maxrowl)
	integer*2 idata(maxrowl),i2data(maxrowl)
	character*80 ifile, imfile(maxfiles), imfinal, badfile, infile
        character*80 name1,name2,names1,names2,nameo,nameo2
        character*80 med
	character*10 cmode
	character*80 errmsg
	character*1 ans1,ans2,ans3
	logical verbose
      call getarg (1,name1)

c	print *,name1
      call getarg (2,name2)
c	print *,name2
      call getarg (3,nameo)
c	print *,nameo
      call getarg (4,nameo2)
c	print *,nameo2
      call getarg (5,cmode)
c	print *,cmode
	read(cmode,'(i2)')mode
c	print *,mode
      call getarg (6,cmode)
c	print *,cmode
	read(cmode,'(f4.0)')value
c	print *,value
      call getarg (7,med)
c	print *,med
c	open (21,file=names1,status='old')
c	open (22,file=names2,status='old')
		call imopen (name1, 1, im1, ier)
		if (ier.ne.0) goto 900
		call imgsiz (im1, axlen, naxis, dtype, ier)	
		if (ier.ne.0) goto 900
	nc = axlen(1)
	nl = axlen(2)
		call imopen (name2, 1, im2, ier)
		if (ier.ne.0) goto 900
		call imopen (med, 1, im5, ier)
		if (ier.ne.0) goto 900

c create the output image - same as first image in list
        dtype=3
	call imcrea(nameo,axlen,naxis,dtype,ier)
	call imopen(nameo,3,im3,ier)
	if(mode.eq.0)then
	call imcrea(nameo2,axlen,naxis,dtype,ier)
	call imopen(nameo2,3,im4,ier)
	endif
c load up the 2 images and the variance image

	do 200 i = 1, nl
        call imgl2r (im1, odata(1), i, ier)
c	print*,i,(odata(jok),jok=1,20)
        do 1674 kkk=1,nc
 1674      data1(kkk,i)=odata(kkk)
        call imgl2r (im2, odata(1), i, ier)
c	print*,i,j,(odata(jok),jok=1,20)
        do 1675 kkk=1,nc
 1675      data2(kkk,i)=odata(kkk)
        call imgl2r (im5, odata(1), i, ier)
c	print*,i,j,(odata(jok),jok=1,20)
        do 2675 kkk=1,nc
 2675      datam(kkk,i)=odata(kkk)
200	continue
c	print*,((data1(nnn,mmm),nnn=3095,3195),mmm=2994,3007)
c	print*,'**********'
c	print*,((data2(nnn,mmm),nnn=3095,3195),mmm=2994,3007)

c now do section comparisons 3pix wide by 20 long
	ix=1
 400	if(ix.gt.nc)goto 401
	ix2=ix+2
	if(ix2.gt.nc)ix2=nc
	iy=1
 500	if(iy.gt.nl)goto 501
	iy2=iy+19
	if(iy2.gt.nl)iy2=nl

c form scaling ratio from a box
	ij=0
      do 1600 i=ix,ix2
		 do 1601 j=iy,iy2
		    ij=ij+1
		    datat2(ij)=data2(i,j)
 1601		    datat(ij)=data1(i,j)
 1600		    continue
c          print*,ix,ix2,iy,iy2,ij,(datat(ik),ik=1,10)
c  form a sort of median in both boxes to get the mean ratio of fluxes
        call asrtr(datat,datat,ij)
        call asrtr(datat2,datat2,ij)
	xsum1=0
	xsum2=0
	do 1234 ijj=1,ij-4
	xsum1=xsum1+datat(ijj)
	xsum2=xsum2+datat2(ijj)
 1234	continue
	stat1=xsum1/float(ij-4)
	stat2=xsum2/float(ij-4)
	if((stat2.gt.20).or.(stat1.gt.20))then
	   ratio=stat1/stat2
	   else
c for low signal cases
	      ratio=1.0
	      endif
c now look at pixels in that box
	      do 600 i=ix,ix2
		 do 601 j=iy,iy2
c so the statistical check for a cosmic is
c
c  pix1 - pix2*ratio > value*rms 
c
c where ratio is the flux ratio of image 1 to image 2 in a 2x20 box around the pixel, 
c and value is set to 10
c
		    stat=value*datam(i,j)
		    data3(i,j)=0
		    diff=data1(i,j)-data2(i,j)*ratio
		    diff2=data2(i,j)-data1(i,j)/ratio

c 3 is the mask value for column interpolation

		    if(diff.gt.stat)then
                    data3(i,j)=3

		    endif
c if doing two files at once
		    if(mode.eq.0)then
		    data4(i,j)=0
		    diff=data2(i,j)-data1(i,j)/ratio
		    if(diff.gt.stat)data4(i,j)=3
		    endif
 601		    continue
 600		    continue
		    iy=iy+20
		    goto 500
 501		    ix=ix+3
		    goto  400
 401		     continue

c write it out

		     do 4310 kk=1,nl
			do4311 jj=1,nc
			idata(jj)=data4(jj,kk)
 4311			i2data(jj)=data3(jj,kk)
       	call impl2s  (im3, i2data(1), kk, ier)
	if(mode.eq.0)call impl2s  (im4, idata(1),kk, ier)
 4310	continue
	call imclos(im1)
	call imclos(im2)
	call imclos(im3)
	call imclos(im4)
	stop
 900	print *, "something wrong"
	print *, ier
	stop
	end

