# File tres/Scripts/trelearn.cl
# By Doug Mink, Center for Astrophysics
# February 25, 2008

# HRELEARN -- Update parameter files for all of the tasks in Hectospec package

procedure hrelearn ()

bool verbose=yes	{prompt="List tasks as parameters files are relearned (yes or no)"}

begin
    bool vb
    vb = verbose
    
    relearn ("dohspec")
    if (vb)
	print ("HRELEARN: DOHSPEC relearned")
    relearn ("hflat")
    if (vb)
	print ("HRELEARN: HFLAT relearned")
    relearn ("hflat1")
    if (vb)
	print ("HRELEARN: HFLAT1 relearned")
    relearn ("hmerge")
    if (vb)
	print ("HRELEARN: HMERGE relearned")
    relearn ("hmerge1")
    if (vb)
	print ("HRELEARN: HMERGE1 relearned")
    relearn ("hpreamp")
    if (vb)
	print ("HRELEARN: HPREAMP relearned")
    relearn ("hpreamp1")
    if (vb)
	print ("HRELEARN: HPREAMP1 relearned")
    relearn ("hgain1")
    if (vb)
	print ("HRELEARN: HGAIN1 relearned")
    relearn ("hproc")
    if (vb)
	print ("HRELEARN: HPROC relearned")
    relearn ("hproc1")
    if (vb)
	print ("HRELEARN: HPROC1 relearned")
    relearn ("fxstat")
    if (vb)
	print ("HRELEARN: FXSTAT relearned")
    relearn ("hcal")
    if (vb)
	print ("HRELEARN: HCAL relearned")
    relearn ("hlin")
    if (vb)
	print ("HRELEARN: HLIN relearned")
    relearn ("hlin1")
    if (vb)
	print ("HRELEARN: HLIN1 relearned")
    relearn ("makeflat")
    if (vb)
	print ("HRELEARN: MAKEFLAT relearned")
    relearn ("hcosmic")
    if (vb)
	print ("HRELEARN: HCOSMIC relearned")
    relearn ("hextract")
    if (vb)
	print ("HRELEARN: HEXTRACT relearned")
    relearn ("hextract1")
    if (vb)
	print ("HRELEARN: HEXTRACT1 relearned")
    relearn ("hscombine")
    if (vb)
	print ("HRELEARN: HSCOMBINE relearned")
    relearn ("maketran")
    if (vb)
	print ("HRELEARN: MAKETRAN relearned")
    relearn ("htran")
    if (vb)
	print ("HRELEARN: HTRAN relearned")
    relearn ("htran1")
    if (vb)
	print ("HRELEARN: HTRAN1 relearned")
    relearn ("habsky")
    if (vb)
	print ("HRELEARN: HABSKY relearned")
    relearn ("habsky1")
    if (vb)
	print ("HRELEARN: HABSKY1 relearned")
    relearn ("hredleak1")
    if (vb)
	print ("HRELEARN: HREDLEAK1 relearned")
    relearn ("hsplit")
    if (vb)
	print ("HRELEARN: HSPLIT relearned")
    relearn ("hskyproc")
    if (vb)
	print ("HRELEARN: HSKYPROC relearned")
    relearn ("fxstat")
    if (vb)
	print ("HRELEARN: FXSTAT relearned")
    relearn ("filename")
    if (vb)
	print ("HRELEARN: FILENAME relearned")
    relearn ("fileroot")
    if (vb)
	print ("HRELEARN: FILEROOT relearned")
    relearn ("fixdir")
    if (vb)
	print ("HRELEARN: FIXDIR relearned")
    relearn ("gettime")
    if (vb)
	print ("HRELEARN: GETTIME relearned")
    relearn ("imgetp")
    if (vb)
	print ("HRELEARN: IMGETP relearned")
    relearn ("padstr")
    if (vb)
	print ("HRELEARN: PADSTR relearned")
    relearn ("round")
    if (vb)
	print ("HRELEARN: ROUND relearned")
    relearn ("smatch")
    if (vb)
	print ("HRELEARN: SMATCH relearned")

    hectospec.version = hectospec.newversion
    if (vb)
	print ("HRELEARN: HECTOSPEC parameters updated to ",hectospec.newversion)

end

# Jan 28 2008	New task, long overdue
# Feb 21 2008	Add HPROC1, HPREAMP1, HFLAT1, HMERGE1, HGAIN1
# Feb 25 2008	Add HEXTRACT1
